unit Unt_MR_Corretor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ImgList, Buttons, ComCtrls, LED,Constantes, Spin, Salas;

type
  Tfrm_MR_Corredor = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    BB_P1: TBitBtn;
    BB_P2: TBitBtn;
    IL_P: TImageList;
    GB_Parede: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    BB_G1: TBitBtn;
    Btn_Sair: TButton;
    Label4: TLabel;
    Label3: TLabel;
    Label13: TLabel;
    LL_Mov_Cor: TLEDLabel;
    Edit1: TSpinEdit;
    procedure FormShow(Sender: TObject);
    procedure Btn_SairClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure BB_G1Click(Sender: TObject);
    procedure BB_P1Click(Sender: TObject);
    procedure BB_P2Click(Sender: TObject);
    procedure LL_Mov_CorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    SimCorredor: TCorredor;
  public
    { Public declarations }
  MR_Corredor_ID : String;
  end;

var
  frm_MR_Corredor: Tfrm_MR_Corredor;

implementation

uses Unt_main;

{$R *.DFM}

procedure Tfrm_MR_Corredor.FormShow(Sender: TObject);
begin
   //Pego o Corredor sobre o qual trabalharemos
   SimCorredor:= frm_main.Sim_Andar.obterCorredor ( MR_Corredor_ID );

   self.Caption:=  'Mundo Real - Seo de Corredor ID ' + MR_Corredor_ID;

   IL_P.GetBitmap(0,BB_P1.Glyph);
   IL_P.GetBitmap(0,BB_P2.Glyph);
   IL_P.GetBitmap(2,BB_G1.Glyph);

      if StrtoInt(Edit1.Text) = 0
       then
           Begin
               BB_G1.Enabled     := False;
           end
       else
           Begin
               BB_G1.Enabled     := True;
           end;

   //Pegando status atual das portas
   if SimCorredor.obterPorta(0).obterestado then
      BB_P1.Caption:= 'Fechar'
   else
       BB_P1.Caption:= 'Abrir';

   if SimCorredor.obterPorta(1).obterestado then
      BB_P2.Caption:= 'Fechar'
   else
       BB_P2.Caption:= 'Abrir';

   //Estado atual das luzes
   if SimCorredor.obterLuz.obterEstado then
      BB_G1.Caption:= 'Acender'
   else
       BB_G1.Caption:= 'Apagar';

   //Sensor de movimento
   if (SimCorredor.obterSensorMov(0).obterEstado <> 0) then
      LL_Mov_Cor.Color:= lcGreen
   else
       LL_Mov_Cor.Color:= lcRed;

   if (SimCorredor.obterSensorMov(0).obterFalha) then
      LL_Mov_Cor.Caption:= 'Falhando'
   else
       LL_Mov_Cor.Caption:= 'Ativo';

   //Numero de pessoas no corredor
   Edit1.Value:= SimCorredor.ObterOcupacao;
end;

procedure Tfrm_MR_Corredor.Btn_SairClick(Sender: TObject);
begin
   self.Close;
end;

procedure Tfrm_MR_Corredor.Edit1Change(Sender: TObject);
begin
     if (SimCorredor.obterOcupacao < Edit1.Value) then
        SimCorredor.incOcupacao
     else
         SimCorredor.decOcupacao;

if Edit1.Value = 0
       then
           Begin
               BB_G1.Enabled     := False;
           end
       else
           Begin
               BB_G1.Enabled     := True;
           end;
end;

procedure Tfrm_MR_Corredor.BB_G1Click(Sender: TObject);
begin
SimCorredor.manipularbotao(0);

if BB_G1.Caption = 'Acender'
       then
           Begin
           BB_G1.Glyph := NIL;
           IL_P.GetBitmap(3,BB_G1.Glyph);
           BB_G1.Caption := 'Apagar';
           end
       else
           Begin
           BB_G1.Glyph := NIL;
           IL_P.GetBitmap(2,BB_G1.Glyph);
           BB_G1.Caption := 'Acender';
           end;
end;

procedure Tfrm_MR_Corredor.BB_P1Click(Sender: TObject);
begin
SimCorredor.obterporta(0).mudarEstadoPorta;

   if BB_P1.Caption = 'Abrir'
       then
           Begin
           BB_P1.Glyph := NIL;
           IL_P.GetBitmap(1,BB_P1.Glyph);
           BB_P1.Caption := 'Fechar';
           end
       else
           Begin
           BB_P1.Glyph := NIL;
           IL_P.GetBitmap(0,BB_P1.Glyph);
           BB_P1.Caption := 'Abrir';
           end;
end;

procedure Tfrm_MR_Corredor.BB_P2Click(Sender: TObject);
begin
SimCorredor.obterporta(1).mudarEstadoPorta;

   if BB_P2.Caption = 'Abrir'
       then
           Begin
           BB_P2.Glyph := NIL;
           IL_P.GetBitmap(1,BB_P2.Glyph);
           BB_P2.Caption := 'Fechar';
           end
       else
           Begin
           BB_P2.Glyph := NIL;
           IL_P.GetBitmap(0,BB_P2.Glyph);
           BB_P2.Caption := 'Abrir';
           end;
end;

procedure Tfrm_MR_Corredor.LL_Mov_CorClick(Sender: TObject);
begin
 If LL_Mov_Cor.Caption = 'Ativo'
     then
     begin
        LL_Mov_Cor.Caption := 'Falha';
        LL_Mov_Cor.Color   := lcRed;
     end
     else
     Begin
        LL_Mov_Cor.Caption := 'Ativo';
        LL_Mov_Cor.Color   := lcGreen;
     end;
end;

procedure Tfrm_MR_Corredor.FormCreate(Sender: TObject);
begin
     SimCorredor:= TCorredor.Create ('' , nil);
end;

end.
