unit Unt_MR_Sala;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, StdCtrls, Buttons, ComCtrls, LED,Constantes, Spin, Salas;

type
  Tfrm_MR_Sala = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BB_P1: TBitBtn;
    BB_P2: TBitBtn;
    IL_P: TImageList;
    Btn_Sair: TButton;
    GB_PC: TGroupBox;
    TrackBar1: TTrackBar;
    Label4: TLabel;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    GB_Parede: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    BB_G1: TBitBtn;
    BB_G2: TBitBtn;
    Label13: TLabel;
    LL_Mov: TLEDLabel;
    Label14: TLabel;
    BB_P3: TBitBtn;
    Label15: TLabel;
    Label16: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    Edit1: TSpinEdit;
    procedure FormShow(Sender: TObject);
    procedure BB_P1Click(Sender: TObject);
    procedure BB_P2Click(Sender: TObject);
    procedure Btn_SairClick(Sender: TObject);
    procedure BB_G1Click(Sender: TObject);
    procedure BB_G2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure LL_MovClick(Sender: TObject);
    procedure BB_P3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    SimSala: TSala;
  public
    { Public declarations }
    MR_Sala_ID : String;
  end;

var
  frm_MR_Sala: Tfrm_MR_Sala;


implementation
uses Unt_Main;

{$R *.DFM}

procedure Tfrm_MR_Sala.FormShow(Sender: TObject);
begin
Self.Caption :=  'Mundo Real - Sala ID ' + MR_Sala_ID;

   IL_P.GetBitmap(0,BB_P1.Glyph);
   IL_P.GetBitmap(0,BB_P2.Glyph);
   IL_P.GetBitmap(0,BB_P3.Glyph);
   IL_P.GetBitmap(2,BB_G1.Glyph);
   IL_P.GetBitmap(2,BB_G2.Glyph);

      if StrtoInt(Edit1.Text) = 0
       then
           Begin
               GB_PC.Enabled     := False;
               GB_Parede.Enabled := False;
               TrackBar1.Enabled := False;
               TrackBar2.Enabled := False;
               TrackBar3.Enabled := False;
               TrackBar4.Enabled := False;
               TrackBar5.Enabled := False;
               BB_G1.Enabled     := False;
               BB_G2.Enabled     := False;
           end
       else
           Begin
               GB_PC.Enabled     := True;
               GB_Parede.Enabled := True;
               TrackBar1.Enabled := True;
               TrackBar2.Enabled := True;
               TrackBar3.Enabled := True;
               TrackBar4.Enabled := True;
               TrackBar5.Enabled := True;
               BB_G1.Enabled     := True;
               BB_G2.Enabled     := True;
           end;

   SimSala:= frm_main.Sim_Andar.obterSala(MR_SALA_ID);


end;

procedure Tfrm_MR_Sala.BB_P1Click(Sender: TObject);
begin
SimSala.obterporta(0).mudarestadoporta;

   if BB_P1.Caption = 'Abrir'
       then
           Begin
           BB_P1.Glyph := NIL;
           IL_P.GetBitmap(1,BB_P1.Glyph);
           BB_P1.Caption := 'Fechar';
           end
       else
           Begin
           BB_P1.Glyph := NIL;
           IL_P.GetBitmap(0,BB_P1.Glyph);
           BB_P1.Caption := 'Abrir';
           end;

   //Obtendo T1
   trackBar1.Position:= SimSala.obterT1;

   //Obtendo o Estado das portas
   if SimSala.obterPorta(0).ObterEstado then
      BB_P1.Caption:= 'Fechar'
   else
       BB_P1.Caption:= 'Abrir';

   if SimSala.obterPorta(1).ObterEstado then
      BB_P2.Caption:= 'Fechar'
   else
       BB_P2.Caption:= 'Abrir';

   if SimSala.obterPorta(2).ObterEstado then
      BB_P3.Caption:= 'Fechar'
   else
       BB_P3.Caption:= 'Abrir';

   //Obtendo ocupacao
   Edit1.Value:= SimSala.obterOcupacao;

   //Obtendo nivel de iluminacao atual
   ProgressBar1.Position:= SimSala.obterLuz(0).ObterEstado;
   ProgressBar2.Position:= SimSala.obterLuz(1).ObterEstado;

   //Estado do sensor
   if (SimSala.obterSensorMov.obterFalha) then
      begin
      LL_Mov.Caption:= 'Falhando';
      LL_Mov.Color:= lcRed;
      end
   else
       begin
       LL_Mov.Caption:= 'Ativo';
       LL_Mov.Color:= lcGreen;
       end;

   //Iluminacao padrao
   TrackBar2.Position:= SimSala.ObterLuz(0).obterInsPadrao;
   TrackBar3.Position:= SimSala.ObterLuz(0).obterInsPadrao;

   //Iluminacao escolhida
   TrackBar4.Position:= SimSala.ObterLuz(0).obterInsEscolhida;
   TrackBar5.Position:= SimSala.ObterLuz(0).obterInsEscolhida;
end;

procedure Tfrm_MR_Sala.BB_P2Click(Sender: TObject);
begin
SimSala.obterporta(1).mudarestadoporta;

   if BB_P2.Caption = 'Abrir'
       then
           Begin
           BB_P2.Glyph := NIL;
           IL_P.GetBitmap(1,BB_P2.Glyph);
           BB_P2.Caption := 'Fechar';
           end
       else
           Begin
           BB_P2.Glyph := NIL;
           IL_P.GetBitmap(0,BB_P2.Glyph);
           BB_P2.Caption := 'Abrir';
           end;
end;

procedure Tfrm_MR_Sala.Btn_SairClick(Sender: TObject);
begin
   frm_MR_Sala.Close;
end;

procedure Tfrm_MR_Sala.BB_G1Click(Sender: TObject);
begin
SimSala.manipularbotao(0);

if BB_G1.Caption = 'Acender'
       then
           Begin
           BB_G1.Glyph := NIL;
           IL_P.GetBitmap(3,BB_G1.Glyph);
           BB_G1.Caption := 'Apagar';
           end
       else
           Begin
           BB_G1.Glyph := NIL;
           IL_P.GetBitmap(2,BB_G1.Glyph);
           BB_G1.Caption := 'Acender';
           end;
end;

procedure Tfrm_MR_Sala.BB_G2Click(Sender: TObject);
begin
SimSala.manipularbotao(1);

if BB_G2.Caption = 'Acender'
       then
           Begin
           BB_G2.Glyph := NIL;
           IL_P.GetBitmap(3,BB_G2.Glyph);
           BB_G2.Caption := 'Apagar';
           end
       else
           Begin
           BB_G2.Glyph := NIL;
           IL_P.GetBitmap(2,BB_G2.Glyph);
           BB_G2.Caption := 'Acender';
           end;
end;

procedure Tfrm_MR_Sala.Edit1Change(Sender: TObject);
var
   oldValue: Integer;
begin
     oldValue:= SimSala.ObterOcupacao;
     if OldValue > Edit1.Value then
        SimSala.decOcupacao
     else
         SimSala.incOcupacao;

   if Edit1.Value = 0
       then
           Begin
               GB_PC.Enabled     := False;
               GB_Parede.Enabled := False;
               TrackBar1.Enabled := False;
               TrackBar2.Enabled := False;
               TrackBar3.Enabled := False;
               TrackBar4.Enabled := False;
               TrackBar5.Enabled := False;
               BB_G1.Enabled     := False;
               BB_G2.Enabled     := False;
           end
       else
           Begin
               GB_PC.Enabled     := True;
               GB_Parede.Enabled := True;
               TrackBar1.Enabled := True;
               TrackBar2.Enabled := True;
               TrackBar3.Enabled := True;
               TrackBar4.Enabled := True;
               TrackBar5.Enabled := True;
               BB_G1.Enabled     := True;
               BB_G2.Enabled     := True;
           end;
end;

procedure Tfrm_MR_Sala.LL_MovClick(Sender: TObject);
begin
  If LL_Mov.Caption = 'Ativo'
     then
     begin
        SimSala.ObterSensorMov.SimularFalha;

        LL_Mov.Caption := 'Falha';
        LL_Mov.Color   := lcRed;
     end
     else
     Begin
        SimSala.ObterSensorMov.SimularFalha;

        LL_Mov.Caption := 'Ativo';
        LL_Mov.Color   := lcGreen;
     end;
end;

procedure Tfrm_MR_Sala.BB_P3Click(Sender: TObject);
begin
SimSala.obterporta(2).mudarestadoporta;

   if BB_P3.Caption = 'Abrir'
       then
           Begin
           BB_P3.Glyph := NIL;
           IL_P.GetBitmap(1,BB_P3.Glyph);
           BB_P3.Caption := 'Fechar';
           end
       else
           Begin
           BB_P3.Glyph := NIL;
           IL_P.GetBitmap(0,BB_P3.Glyph);
           BB_P3.Caption := 'Abrir';
           end;
end;

procedure Tfrm_MR_Sala.TrackBar1Change(Sender: TObject);
begin
     SimSala.DefinirT1(TrackBar1.Position);
end;

procedure Tfrm_MR_Sala.TrackBar4Change(Sender: TObject);
begin
     SimSala.ObterLuz(0).definirInsEscolhida(TrackBar4.Position);
end;

procedure Tfrm_MR_Sala.TrackBar5Change(Sender: TObject);
begin
     SimSala.ObterLuz(1).definirInsEscolhida(TrackBar4.Position);
end;

procedure Tfrm_MR_Sala.TrackBar2Change(Sender: TObject);
begin
     SimSala.ObterLuz (0).DefinirInsPadrao(TrackBar2.Position);
end;

procedure Tfrm_MR_Sala.TrackBar3Change(Sender: TObject);
begin
     SimSala.ObterLuz (1).DefinirInsPadrao(TrackBar2.Position);
end;

procedure Tfrm_MR_Sala.FormCreate(Sender: TObject);
begin
     SimSala:= TSala.Create('', nil,0);
end;

end.
