unit Unt_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, StdCtrls, Grids, ComCtrls, LED, ImgList, Buttons,
//Units Importadas do projeto
  Constantes, Andares, LuzesCorredor, LuzesSala, Portas, Salas;


type
  Tfrm_main = class(TForm)
    Bevel4: TBevel;
    Bevel5: TBevel;
    imgFacilityManager: TImage;
    imgMundoReal: TImage;
    Bevel3: TBevel;
    lblFacilityManager: TLabel;
    lblmundoReal: TLabel;
    grpLogFalhas: TGroupBox;
    grpComandos: TGroupBox;
    Button1: TButton;
    btn_power: TButton;
    LB_Log: TListBox;
    btn_ClrLog: TButton;
    grpMedidores: TGroupBox;
    lblilumDesejada: TLabel;
    IlumEfetiva: TLabel;
    lblLuzSol: TLabel;
    PB_Desejada: TProgressBar;
    PB_Efetiva: TProgressBar;
    PB_APSol: TProgressBar;
    MainClock: TTimer;
    btn_Nova: TButton;
    btn_Sobre: TButton;
    lblConsulmoPassado: TLabel;
    Label7: TLabel;
    LED_Sensor5: TLED;
    Label8: TLabel;
    SBBtn: TSpeedButton;
    IL: TImageList;
    LBSun: TLabel;
    lblConsumoPresente: TLabel;
    Label10: TLabel;
    MapaCor: TImage;
    LED_Sensor1: TLED;
    LED_Sensor3: TLED;
    LED_Sensor2: TLED;
    LED_Sensor4: TLED;
    LED_Sensor6: TLED;
    btn_sinal: TButton;
    TrackBar1: TTrackBar;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    btnConsumo: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btn_powerClick(Sender: TObject);
    procedure btn_ClrLogClick(Sender: TObject);
    procedure MainClockTimer(Sender: TObject);
    procedure imgFacilityManagerClick(Sender: TObject);
    procedure imgFacilityManagerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgMundoRealMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgMundoRealClick(Sender: TObject);
    procedure btn_SobreClick(Sender: TObject);
    procedure SBBtnClick(Sender: TObject);
    procedure btn_sinalClick(Sender: TObject);
    procedure btn_NovaClick(Sender: TObject);
    procedure btnConsumoClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);

  private
    { Private declarations }
    PowerOn: Boolean;

  public
    { Public declarations }
    Sim_Andar: TAndar;
  end;

var
  frm_main: Tfrm_main;
  Direcao : Integer;

implementation

uses Unt_Sala, Unt_Corredor, Unt_MR_Sala, Unt_MR_Corretor, Unt_Sobre;

Var
   FM_ID       : String = '';
   RM_ID       : String = '';
   Xp,Yp,Xr,Yr : Integer;

{$R *.DFM}

procedure Tfrm_main.FormShow(Sender: TObject);
begin
     imgMundoReal.Picture := imgFacilityManager.Picture;
     sleep(300);

     //Carregando os mapas do andar
     imgFacilityManager.Enabled := True;
     imgMundoReal.Enabled := True;

     //Colocando a seta indicativa da direcao do sol na posio correta
     IL.GetBitmap(0,SbBtn.Glyph);

     //Setando a direo do sol
     Direcao := 1;

     //O sistema comea desligado
     PowerOn:= False;
end;

procedure Tfrm_main.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure Tfrm_main.btn_powerClick(Sender: TObject);
begin
  if btn_power.Caption = '&Ligar'
     then
        begin
        //Atualiza o boto de "Ligar" para que este fique como opo de desligar o sistema
        btn_power.Caption := '&Desligar';

        //Informa na tela de LOG que o sistema foi ativado
        LB_Log.Items.Add('Sistema Ligado.');
        LB_Log.Items.Add('-----------------------------------------');
        LB_Log.Items.Add('Tempo contado em ' + IntToStr (TimeUnit) + ' milisegundos.');

        //Crio o andar para a simulao
        Sim_Andar:= TAndar.Create;

        Application.ProcessMessages;
        MainClock.Enabled := True;

        PowerOn:= TRUE;
        end
     else
        begin
        //Atualiza o boto de "Desligar" para que este fique como opo de ligar o sistema
        btn_power.Caption := '&Ligar';

        //Informa na tela de LOG que o sistema est desligado
        LB_Log.Items.Add('Sistema Desligado. ');

        //Destrouo o andar que vinha sendo utilizado
        Sim_Andar.Destroy;

        Application.ProcessMessages;

        MainClock.Enabled := False;

        PB_Desejada.Position := 0;
        PB_Efetiva.Position  := 0;
        PB_APSol.Position    := 0;

        PowerOn:= FALSE;
        end;
end;

procedure Tfrm_main.btn_ClrLogClick(Sender: TObject);
begin
  LB_Log.Clear;
end;

procedure Tfrm_main.MainClockTimer(Sender: TObject);
begin
   PB_Desejada.Position := 1;//Corrigir
   PB_Efetiva.Position  := 1;//Corrigir
   PB_APSol.Position    := PB_Desejada.Position - PB_Efetiva.Position;
end;

procedure Tfrm_main.imgFacilityManagerClick(Sender: TObject);
begin
     if PowerOn then
        begin
        FM_ID := 'ZZZZZZZZZ';

        // Identificando o Sensor ou posio do mapa que foi clicada
          //SENSORES
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0086002F'
           then FM_ID := 'ols1';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00AC1E00'
           then FM_ID := 'ols2';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0009AE00'
           then FM_ID := 'ols3';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00420078'
           then FM_ID := 'ols4';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00BE00C9'
           then FM_ID := 'ols5';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0085A101'
           then FM_ID := 'ols6';

        // SALAS IMPARES
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00AEBBFF'
           then FM_ID := 'O435';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0093CCFF'
           then FM_ID := 'O433';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0086FFEA'
           then FM_ID := 'O431';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0093FFCB'
           then FM_ID := 'O429';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00A6FFA1'
           then FM_ID := 'M427';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00EDFFA1'
           then FM_ID := 'O425';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FFD893'
           then FM_ID := 'O423';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FF9486'
           then FM_ID := 'O421';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FFA1AC'
           then FM_ID := 'O419';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FF93B3'
           then FM_ID := 'O417';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FF86DB'
           then FM_ID := 'O415';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00D8A0FF'
           then FM_ID := 'P413';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$008E5DFF'
           then FM_ID := 'HL411';

        // CORREDORES
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00380CFF'
           then FM_ID := 'H3';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0000948A'
           then FM_ID := 'H2';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$000142BC'
           then FM_ID := 'H1';

        // SALAS PARES
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$001B86FF'
           then FM_ID := 'CL426';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$001BFFF2'
           then FM_ID := 'O424';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0000FF96'
           then FM_ID := 'CL422';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$0093FF19'
           then FM_ID := 'P420';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FFC60D'
           then FM_ID := 'CL418';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FF8D0E'
           then FM_ID := 'O416';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FF0D1B'
           then FM_ID := 'O414';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00FF19A1'
           then FM_ID := 'O412';
        if ColorToString(MapaCor.Canvas.Pixels[Xp,Yp]) = '$00A400FF'
           then FM_ID := 'HL410';

        //FM_ID tem o nmero da sala ou seo de corredor selecionado, caso a seleo
        // tenha sido invlida, ter ZZZZZZZZZ como valor atribudo.

        //Caso a seleo vlida tenha sido uma sala
        if (((FM_ID[1] = 'O') or ((FM_ID[1] = 'C') or ( FM_ID[1] = 'M'))) or
           ((FM_ID[1] = 'H') and (FM_ID[2] = 'L'))) then
           begin
           frm_FM_Sala.FM_Sala_ID := FM_ID;
           frm_FM_Sala.showModal;
           exit;
           end;

        //Caso a seleo vlida tenha sido uma seo de corredor
        if (FM_ID[1] = 'H') then
           begin
           frm_FM_Corredor.FM_Corredor_ID := FM_ID;
           frm_FM_Corredor.showModal;
           exit;
           end;

        //Caso a seleo vlida tenha sido um dos sensores externos de luz
        if FM_ID = 'ols1' then
           ShowMessage('Sensor Ativo - 500 Lux');
        if FM_ID = 'ols2' then
           ShowMessage('Sensor Ativo - 500 Lux');
        if FM_ID = 'ols3' then
           ShowMessage('Sensor Ativo - 500 Lux');
        if FM_ID = 'ols4' then
           ShowMessage('Sensor Ativo - 500 Lux');
        if FM_ID = 'ols5' then
           ShowMessage('Sensor Ativo - 500 Lux');
        if FM_ID = 'ols6' then
           ShowMessage('Sensor Ativo - 500 Lux');

        //Caso a seleo tenha sido feita de uma das suas no controladas pelo sistema
        if FM_ID[1] = 'P' then
           ShowMessage('A Sala ' + FM_ID + 'no est sob o controle do sistema.');
        end; //if PowerOn
end;

procedure Tfrm_main.imgFacilityManagerMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     Xp := X;
     Yp := Y;
end;

procedure Tfrm_main.imgMundoRealMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     Xr := X;
     Yr := Y;
end;

procedure Tfrm_main.imgMundoRealClick(Sender: TObject);
begin
     if PowerOn then
        begin
        RM_ID := 'ZZZZZZZZZ';

        // Sensores ******************
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0086002F'
           then RM_ID := 'ols1';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00AC1E00'
           then RM_ID := 'ols2';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0009AE00'
           then RM_ID := 'ols3';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00420078'
           then RM_ID := 'ols4';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00BE00C9'
           then RM_ID := 'ols5';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0085A101'
           then RM_ID := 'ols6';

        // Salas Impares *************
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00AEBBFF'
           then RM_ID := 'O435';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0093CCFF'
           then RM_ID := 'O433';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0086FFEA'
           then RM_ID := 'O431';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0093FFCB'
           then RM_ID := 'O429';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00A6FFA1'
           then RM_ID := 'M427';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00EDFFA1'
           then RM_ID := 'O425';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FFD893'
           then RM_ID := 'O423';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FF9486'
           then RM_ID := 'O421';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FFA1AC'
           then RM_ID := 'O419';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FF93B3'
           then RM_ID := 'O417';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FF86DB'
           then RM_ID := 'O415';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00D8A0FF'
           then RM_ID := 'P413';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$008E5DFF'
           then RM_ID := 'HL411';

        // corredores *****************
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00380CFF'
           then RM_ID := 'H3';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0000948A'
           then RM_ID := 'H2';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$000142BC'
           then RM_ID := 'H1';
        // Salas Pares ****************
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$001B86FF'
           then RM_ID := 'CL426';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$001BFFF2'
           then RM_ID := 'O424';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0000FF96'
           then RM_ID := 'CL422';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$0093FF19'
           then RM_ID := 'P420';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FFC60D'
           then RM_ID := 'CL418';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FF8D0E'
           then RM_ID := 'O416';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FF0D1B'
           then RM_ID := 'O414';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00FF19A1'
           then RM_ID := 'O412';
        if ColorToString(MapaCor.Canvas.Pixels[Xr,Yr]) = '$00A400FF'
           then RM_ID := 'HL410';

        if (((RM_ID[1] = 'O') or ((RM_ID[1] = 'C') or ( RM_ID[1] = 'M'))) or
           ((RM_ID[1] = 'H') and (RM_ID[2] = 'L'))) then
           begin
           frm_MR_Sala.MR_Sala_ID := RM_ID;
           frm_MR_Sala.showModal;
           exit;
           end;

        if RM_ID[1] = 'H' then
           begin
           frm_MR_Corredor.MR_Corredor_ID := RM_ID;
           frm_MR_Corredor.showModal;
           exit;
           end;

        if RM_ID[1] = 'o' then
           begin
           if RM_ID[4] = '1' then
              begin
              Sim_Andar.obterSensorLuz (0).SimularFalha;
              if LED_Sensor1.Color = lcGreen then
                 LED_Sensor1.Color := lcRed
              else
                  LED_Sensor1.Color := lcGreen;
              end;
           if RM_ID[4] = '2' then
              begin
              Sim_Andar.obterSensorLuz (1).SimularFalha;
              if LED_Sensor2.Color = lcGreen then
                 LED_Sensor2.Color := lcRed
              else LED_Sensor2.Color := lcGreen;
              end;
           if RM_ID[4] = '3' then
              begin
              Sim_Andar.obterSensorLuz (2).SimularFalha;
              if LED_Sensor3.Color = lcGreen then
                 LED_Sensor3.Color := lcRed
              else LED_Sensor3.Color := lcGreen;
              end;
           if RM_ID[4] = '4' then
              begin
              Sim_Andar.obterSensorLuz (3).SimularFalha;
              if LED_Sensor4.Color = lcGreen then
                 LED_Sensor4.Color := lcRed
              else LED_Sensor4.Color := lcGreen;
              end;
           if RM_ID[4] = '5' then
              begin
              Sim_Andar.obterSensorLuz (4).SimularFalha;
              if LED_Sensor5.Color = lcGreen then
                 LED_Sensor5.Color := lcRed
              else LED_Sensor5.Color := lcGreen;
              end;
           if RM_ID[4] = '6' then
              begin
              Sim_Andar.obterSensorLuz (5).SimularFalha;
              if LED_Sensor6.Color = lcGreen then
                 LED_Sensor6.Color := lcRed
              else LED_Sensor6.Color := lcGreen;
              end;
           end;//if RM_ID[1] ='o'

        if RM_ID[1] = 'P' then
           ShowMessage('A Sala ' + RM_ID + ' no est sob o controle do sistema.');
        end; //if PowerOn
end;

procedure Tfrm_main.btn_SobreClick(Sender: TObject);
begin
  frm_Sobre.ShowModal;
end;

procedure Tfrm_main.SBBtnClick(Sender: TObject);
begin
     if PowerOn then
        begin
        SbBtn.Glyph := Nil;
        IL.GetBitmap(Direcao,SbBtn.Glyph);
        Application.ProcessMessages;
        Direcao := Direcao + 1;
        if Direcao = 8 then
           Direcao := 0;
        end; //if PowerOn
end;

procedure Tfrm_main.btn_sinalClick(Sender: TObject);
begin
     if PowerOn then
        begin
        if Btn_Sinal.Caption = 'Falhar SSA' then
           begin
           Sim_Andar.simularFalha;

           Btn_Sinal.Caption := 'Restaurar SSA';
           Btn_Sinal.Hint    := 'Restaura sinal de Sistema Ativo';
           end
        else begin
             Sim_Andar.simularFalha;

             Btn_Sinal.Caption := 'Falhar SSA';
             Btn_Sinal.Hint    := 'Falha sinal de Sistema Ativo';
             end;
        end; //if PowerOn
end;

procedure Tfrm_main.btn_NovaClick(Sender: TObject);
begin
     //Crio o andar para a simulao
     Sim_Andar.Destroy;
     Sim_Andar:= TAndar.Create;

     Sim_Andar.iniciarSimulacao(Sim_Andar);
end;

procedure Tfrm_main.btnConsumoClick(Sender: TObject);
var
   Energia: Integer;
begin
     Energia:= pb_Efetiva.Position;
     pb_Efetiva.Position:= Sim_Andar.obterEnergia ( Energia );
end;

procedure Tfrm_main.TrackBar1Change(Sender: TObject);
begin
     Sim_Andar.incIntensidadeAmbiente;
end;

end.
