unit SensorMovimento;

interface

uses Classes       ,
     Constantes    ,
     Sensor        ;

Type
   TSensorMovimento = class ( TSensor )
        public
          constructor Create       ;
          destructor  Destroy      ; override ;
          procedure   simularFalha ;
        end ; // TSensorMovimento

implementation

// cria e inicializa sensor de movimento
constructor TSensorMovimento.Create ;
begin
   inherited Create( ) ;
end ; // TSensorMovimento.Create


// mtodo destrutor do sensor de movimento
destructor TSensorMovimento.Destroy ;
begin
   // no faz nada!
   inherited Destroy( ) ;
end ; // TSensorMovimento.Destroy


// permite falhar ou consertar um sensor de movimento
// se est funcionando corretamente (_falha = false) vai ficar falhado
// se est falhado (_falha = true) vai passar a funcionar corretamente
procedure TSensorMovimento.simularFalha ;
begin
     _falha := NOT _falha ;  // inverte o indicador de falha
     if ( _falha = true )    // vai ficar indicando movimento
     then                    // se sensor de movimento estiver falhado
     begin
        _estado := 1 ;
     end ; // if
end ; // TSensorMovimento.simularFalha

end.
