unit Unt_Corredor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, StdCtrls, Buttons, ComCtrls, LED,
//Importadas do projeto
  Constantes, Salas;

type
  Tfrm_FM_corredor = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    TB_T3: TTrackBar;
    BB_Luzes: TBitBtn;
    IL_Led: TImageList;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Btn_Sair: TButton;
    LED1: TLED;
    LED2: TLED;
    LED3: TLED;
    procedure BB_LuzesClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Btn_SairClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TB_T3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FM_Corredor_ID    : String;
    SimCorredor       : TCorredor;
  end;

var
  frm_FM_corredor: Tfrm_FM_corredor;

implementation
uses unt_main;

{$R *.DFM}

procedure Tfrm_FM_corredor.BB_LuzesClick(Sender: TObject);
begin
    if BB_Luzes.Caption = 'Apagar'
       then
           Begin
           BB_Luzes.Glyph := NIL;
           IL_Led.GetBitmap(0,BB_Luzes.Glyph);
           BB_Luzes.Caption := 'Acender';

           //Comandamos que a luz seja apagada... A classe cuidar do resto
           SimCorredor.apagarLuz;
           end
       else
           Begin
           BB_Luzes.Glyph := NIL;
           IL_Led.GetBitmap(1,BB_Luzes.Glyph);
           BB_Luzes.Caption := 'Apagar';

           //Comandamos que a luz seja acendida... A classe cuidar do resto
           SimCorredor.acenderLuz;
           end;
end;

procedure Tfrm_FM_corredor.FormShow(Sender: TObject);
begin
   self.Caption := 'Mapa da Seo de Corredor - ID ' + FM_Corredor_ID;
   IL_Led.GetBitmap(1,BB_Luzes.Glyph);

   //Pego o Corredor sobre o qual trabalharemos
   SimCorredor:= frm_main.Sim_Andar.obterCorredor ( FM_Corredor_ID );

   //pegando T2 atual
   TB_T3.Position:= SimCorredor.obterT2;

   //Pegando status atual das portas
   if SimCorredor.obterPorta(0).obterestado  then
      label7.Caption:= 'Aberta'
   else
       Label7.Caption:= 'Fechada';

   if SimCorredor.obterPorta(1).obterestado then
      label8.Caption:= 'Aberta'
   else
       Label8.Caption:= 'Fechada';

   //Pegando status atual dos sensores
   if simCorredor.obterSensorMov(0).ObterEstado <> 0 then
      begin
      Label6.Caption:= 'H Movimento';
      LED1.Color:= lcGreen;
      end
   else
       begin
       Label6.Caption:= 'No h Movimento';
       LED1.Color:= lcRed;
       end;

   if simCorredor.obterSensorMov(1).ObterEstado <> 0 then
      begin
      Label11.Caption:= 'H Movimento';
      LED2.Color:= lcGreen;
      end
   else
       begin
       Label11.Caption:= 'No h Movimento';
       LED2.Color:= lcRed;
       end;

   if simCorredor.obterSensorMov(2).ObterEstado <>0 then
      begin
      Label13.Caption:= 'H Movimento';
      LED3.Color:= lcGreen;
      end
   else
       begin
       Label13.Caption:= 'No h Movimento';
       LED3.Color:= lcRed;
       end;

   //Estado atual das luzes
   if SimCorredor.obterLuz.obterEstado then
      BB_Luzes.Caption:= 'Acender'
   else
       BB_Luzes.Caption:= 'Apagar';
end;

procedure Tfrm_FM_corredor.Btn_SairClick(Sender: TObject);
begin
   frm_FM_Corredor.Close;
end;

procedure Tfrm_FM_corredor.FormCreate(Sender: TObject);
begin
     SimCorredor:= TCorredor.Create ('' , nil);
end;

procedure Tfrm_FM_corredor.TB_T3Change(Sender: TObject);
begin
     SimCorredor.definirT2 (TB_T3.Position) ;
end;

end.
